 ** The C_TOD() function for dBASE compatibility

 FUNCTION C_TOD
 ** Purpose   : Replaces CTOD() to allow internal date
 **             arithmetic
 ** Written by: Bob Velke, (c) 1991
 ** Syntax    : C_TOD(<return value>)
 ** Examples  : C_TOD('14/31/1990')
 **             returns {03/03/1991}
 ** Assumes   : SET DATE TO AMERICAN
 PARAMETERS startdate     && assumes mm/dd/yy or
                          && mm/dd/yyyy.
 PRIVATE retval,sm,sd,sy,s1,s2,temp,oldcent,dom
 retval=''
 oldcent=SET('CENTURY')
 SET CENTURY ON
 s1=AT('/',startdate)      && location of first /
 s2=AT('/',startdate,2)    && location of second /
 sm =VAL(LEFT(startdate,s1-1))   && start month
 sd =VAL(SUBSTR(startdate,s1+1,;
                s2-s1-1))        && start day
 sy =VAL(SUBSTR(startdate,s2+1)) && start year
 IF sm0 AND sd0 AND sy0    && no zeros or negative #s
    sy=IIF(BETWEEN(sy,0,99),1900+sy,sy)
    temp=INT(sm/12)        && check months in year
    sm=sm-(12*temp)
    sy=sy+temp
    dom=IIF(sm=12,31,DAY(CTOD(STR(sm+1)+'/01/'+;
            STR(sy,4))-1))
    DO WHILE sddom         && check days of month
       sd=sd-dom
       sm=sm+1
       IF sm=13
          sm=1
          sy=sy+1
       ENDIF
       dom=IIF(sm=12,31,DAY(CTOD(STR(sm+1)+'/01/'+;
               STR(sy,4))-1))
    ENDDO
    retval=STR(sm,2)+'/'+STR(sd,2)+'/'+STR(sy,4)
 ENDIF
 IF oldcent=='OFF'
    SET CENTURY OFF
 ENDIF
 RETURN (CTOD(retval))

