PROC CenterIt(Line.A)
; *********************************************************************
; *
; * CenterIt()
; *
; * Date: 29 Jan 1991
; * Mitchell A. Tracy, Micro Management Specialists
; * (714) 979-2814
; *********************************************************************
PRIVATE ProcName.A, Line.A, Format.A, Width.I
ProcName.A="CenterIt"

CTRLHOME                              ;go to the beginning of the line
Width.I = PAGEWIDTH() - COLNO()       ;now get the width of the page
Format.A = "w"+strval(Width.I)+",ac"  ;use the width to in the format
TYPEIN FORMAT(Format.A,Line.A)        ;and type in the line
ENTER                                 ;hit enter to open the next line
ENDPROC    ;CenterIt

Proc RptLegend(InFile.A,SrceRpt.A,TargRpt.A,LFile.A)
; *********************************************************************
; *
; * RptLegend()
; * Inputs:
; * InFile.A    Table containing the detail records
; * SrceRpt.A   Report that the legend will be based on
; * TargRpt.A   Report that the legend will be applied to
; * LFile.A             Table containing the legend text
; *
; * Date: 29 Jan 1991
; * Mitchell A. Tracy, Micro Management Specialists
; * (714) 979-2814
; *********************************************************************
PRIVATE X, ProcName.A, Format.A, Line.A, InFile.A,
             SrceRpt.A,TargRpt.A,LFile.A, FldTyp.A,
             Legend1.AR, Legend2.AR, NRecs.I
ProcName.A="RptLegend"

COPYREPORT InFile.A SrceRpt.A   ;first copy the report to a
           InFile.A TargRpt.A   ;work area

NRecs.I=NRECORDS(LFile.A)       ;how many records in the legend file
ARRAY Legend1.AR[NRecs.I]       ;now build arrays for each record
ARRAY Legend2.AR[NRecs.I]
VIEW LFile.A
RIGHT                           ;move off the record number
FldTyp.A = FIELDTYPE()
FOR X FROM 1 TO NRECS.I
   SWITCH
        CASE FldTyp.A = "N"     ;if the field is a decimal format it
        OR   FldTyp.A = "$":Legend1.AR[X] = FORMAT("w8.2, ec",[])

                                ;if a short number then format it
        CASE FldTyp.A = "S":Legend1.AR[X] = FORMAT("w8, ec",[])

                                ;otherwise it's a date or char - no fmt
          OTHERWISE        :Legend1.AR[X] = []
        ENDSWITCH

   RIGHT                        ;move to the second column
   Legend2.AR[X] = []           ;put it in the second array
   LEFT DOWN                    ;back to the first column and down
ENDFOR                          ;done with the legend source file

MENU {Report} {Change}          ;now to change the report
SELECT InFile.A                 ;select the file
SELECT TargRpt.A                ;and the report
ENTER                           ;press enter to get past the report title

IF SYSMODE() <> "Report" THEN   ;reality check!
    BEEP                        ;if we're NOT in the report
    MESSAGE("Report update failed")
    SLEEP 2000                  ;then something went wrong
    RETURN False                ;alert the user and abort
ENDIF

END                             ;and go to the bottom of the report
INS                             ;get into insert mode
ENTER                           ;and open up a blank line
Line.A =
"ķ"
CenterIt(Line.A)                ;type in the top of the legend box
FOR X FROM 1 TO NRECS.I         ;loop through the array

        Line.A = " "+FORMAT("w8,al",Legend1.AR[X])+"  "
                     +FORMAT("w55,al",Legend2.AR[X])+" "
        CenterIt(Line.A)        ;type in one line for each array element
ENDFOR

Line.A =
"Ľ"
CenterIt(Line.A)                ;type in the bottom of the box
DO_IT!                          ;save the report
RETURN True                     ;let the calling proc know it's OK
ENDPROC ;RptLegend()
; *********************************************************************
; *
; * Test stub to test the legend procedures
; *
; *********************************************************************
OK=RptLegend("Transact","R","1","Codes")  ;create the legend
IF OK THEN
    REPORT "Transact" "1"               ;print the report
    MENU {Tools} {Delete} {Report}      ;clean up after -
    SELECT "Transact"                   ;and delete the report
    SELECT "1"
ENDIF
CLEARALL                                ;neatness counts!
