* File  WRITE.PRG
* Notes Creates a "structure extended" DBF file from the "thin air"
*       without using BIN routines or external programs.
*       No DBF "seed" file is required.
* Date  02/10/92
*       

PARAMETER cFileName
  
  * Housekeeping chores
  PRIVATE ALL
  cSetTalk = SET("TALK")
  SET TALK OFF

  nLoopCount = 1  && Loop counter
  nDim       = 5  && Number of rows in the DBF structure array

  * Declare array with the structure of the "structure extended" 
  * DBF file   
  DECLARE aDbfStru[nDim,5]

  aDbfStru[1,1] = "FIELD_NAME"   && field name
  aDbfStru[1,2] = "C"            && field type
  aDbfStru[1,3] = 10             && field length
  aDbfStru[1,4] = 0              && number of decimal places    
  aDbfStru[1,5] = "N"            && MDX index tag

  aDbfStru[2,1] = "FIELD_TYPE"
  aDbfStru[2,2] = "C"
  aDbfStru[2,3] =  1
  aDbfStru[2,4] =  0
  aDbfStru[2,5] = "N"

  aDbfStru[3,1] = "FIELD_LEN"
  aDbfStru[3,2] = "N"
  aDbfStru[3,3] = 3
  aDbfStru[3,4] = 0
  aDbfStru[3,5] = "N"

  aDbfStru[4,1] = "FIELD_DEC"
  aDbfStru[4,2] = "N"
  aDbfStru[4,3] = 3
  aDbfStru[4,4] = 0
  aDbfStru[4,5] = "N"

  aDbfStru[5,1] = "FIELD_IDX"
  aDbfStru[5,2] = "C"
  aDbfStru[5,3] = 1
  aDbfStru[5,4] = 0
  aDbfStru[5,5] = "N"

  * Redirect printer output to a file
  SET PRINTER TO FILE (cFileName)
  SET PRINT ON

  * Write DBF file header
  * First byte (byte 0)- DBF file indicator
  ??? '{3}'

  * Creation date - bytes 1-3
  ??? CHR(VAL(RIGHT(STR(YEAR(DATE())),2))) + ;
      CHR(MONTH(DATE())) + CHR(DAY(DATE()))

  * Number of records in the file (zero) - bytes 1-3
  ??? REPLICATE('{0}',4)

  * Number of bytes in the header - bytes 8-9
  ??? '{193}{0}'

  * Number of bytes in the record (19) - bytes 10-11
  ??? '{19}{0}'

  * Bytes 12-31 of the header - not used here
  * Some appear to have constant value
  ??? REPLICATE('{0}',18)
  ??? '{57}{1}'

  * Field descriptor bytes - looping through the array
  * nDim times (5 in this case)
  * Field descriptors are each 32 bytes long
  DO WHILE nLoopCount <= nDim

    * Field name - bytes 0-10
    ??? aDbfStru[nLoopCount,1] +;
        REPLICATE('{0}', 11-LEN(TRIM(aDbfStru[nLoopCount,1])))

    * Field type - byte 11
    ??? aDbfStru[nLoopCount,2]

    * Bytes 12-15 - not used here
    ??? REPLICATE('{0}',2)
    ??? '{238}{85}'

    * Field length - byte 16
    ??? CHR(aDbfStru[nLoopCount,3])

    * Field decimal count - byte 17
    ??? IIF(aDbfStru[nLoopCount,4] > 0, ;
          CHR(aDbfStru[nLoopCount,4]), '{0}')

    * Bytes 18-19 - reserved
    ??? REPLICATE('{0}',2)

    * Byte 20 - work area ID.  Let's use 1 for simplicity
    ??? '{1}'

    * Bytes 21-31 - MDX index tag flag and reserved bytes
    ??? IIF(aDbfStru[nLoopCount,5] $ 'YyTt', '{1}', '{0}')
    ??? REPLICATE('{0}',10)

    * Increment loop counter 
    nLoopCount = nLoopCount + 1
  ENDDO

  * DBF file header terminator and EOF character - byte n+1   
  ??? '{13}{26}'

  SET PRINTER TO
  SET PRINT OFF
  SET TALK &cSetTalk

* EOF: MakeDbf
